# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/pinctrl/qcom,lpass-lpi-common.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Qualcomm SoC LPASS LPI TLMM Common Properties

maintainers:
  - Bjorn Andersson <andersson@kernel.org>
  - Srinivas Kandagatla <srinivas.kandagatla@linaro.org>
  - Krzysztof Kozlowski <krzk@kernel.org>

description:
  Common properties for the Top Level Mode Multiplexer pin controllers in the
  Low Power Audio SubSystem (LPASS) Low Power Island (LPI) of Qualcomm SoCs.

properties:
  gpio-controller: true

  "#gpio-cells":
    description:
      Specifying the pin number and flags, as defined in
      include/dt-bindings/gpio/gpio.h
    const: 2

  gpio-ranges:
    maxItems: 1

required:
  - gpio-controller
  - "#gpio-cells"
  - gpio-ranges

allOf:
  - $ref: pinctrl.yaml#

additionalProperties: true

$defs:
  qcom-tlmm-state:
    properties:
      drive-strength:
        enum: [2, 4, 6, 8, 10, 12, 14, 16]
        default: 2
        description:
          Selects the drive strength for the specified pins, in mA.

      slew-rate:
        enum: [0, 1, 2, 3]
        default: 0
        description: |
          0: No adjustments
          1: Higher Slew rate (faster edges)
          2: Lower Slew rate (slower edges)
          3: Reserved (No adjustments)

      bias-bus-hold: true
      bias-pull-down: true
      bias-pull-up: true
      bias-disable: true
      input-enable: true
      output-high: true
      output-low: true

    required:
      - pins
      - function

    allOf:
      - $ref: pincfg-node.yaml#
      - $ref: pinmux-node.yaml#

    additionalProperties: true

